# coding: utf-8


"""
IGNORE:
    Nutanix Vmm Versioned APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.3-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
import ntnx_vmm_py_client.models
from ntnx_vmm_py_client.models.OneOfvmm.v4.ahv.config.Diskbacking_info import Diskbacking_info  # noqa: F401,E501
from ntnx_vmm_py_client.models.common.v1.response.ApiLink import ApiLink  # noqa: F401,E501
from ntnx_vmm_py_client.models.common.v1.response.ExternalizableAbstractModel import ExternalizableAbstractModel  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.DiskAddress import DiskAddress  # noqa: F401,E501

class Disk(ExternalizableAbstractModel):

    """Virtual Machine disk (VM disk).

    :param disk_address: (:attr:`disk_address`) 
    :type disk_address: 
    :param backing_info: (:attr:`backing_info`) Supporting storage to create virtual disk on.
    :type backing_info: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'disk_address': 'vmm.v4.ahv.config.DiskAddress',
        'backing_info': 'OneOfvmm.v4.ahv.config.Diskbacking_info',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'disk_address': 'diskAddress',
        'backing_info': 'backingInfo',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, disk_address=None, backing_info=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        ExternalizableAbstractModel.__init__(self, ext_id, links, tenant_id, *args, **kwargs)
        self.__disk_address = None
        self.__backing_info = None
        self.discriminator = None
        if disk_address is not None:
            self.__disk_address = disk_address
        if backing_info is not None:
            self.__backing_info = backing_info

    def _initialize_object_type(self):
        return 'vmm.v4.ahv.config.Disk'

    def _initialize_fq_object_type(self):
        return 'vmm.v4.r0.a1.ahv.config.Disk'


    @property
    def disk_address(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.DiskAddress`
        """  # noqa: E501
        return self.__disk_address

    @disk_address.setter
    def disk_address(self, disk_address):

        self.__disk_address = disk_address

    @property
    def backing_info(self):
        """
        Supporting storage to create virtual disk on.

        :type:
                :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.VmDisk` | 
                :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.ADSFVolumeGroupReference`
                    """  # noqa: E501
        return self.__backing_info

    @backing_info.setter
    def backing_info(self, backing_info):

        self.__backing_info = backing_info

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if attr_type.startswith('OneOf'):
                type = getattr(ntnx_vmm_py_client.models, attr_type.split('.')[-1])
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(Disk, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Disk):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

