# coding: utf-8


"""
IGNORE:
    Nutanix Vmm Versioned APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.3-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.Credential import Credential  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.NgtCapability import NgtCapability  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.RebootPreference import RebootPreference  # noqa: F401,E501

class GuestToolsInstallConfig(object):

    """Arguments for installing Nutanix Guest Tools.

    :param capabilities: (:attr:`capabilities`) The list of the application names that are enabled on the guest VM.
    :type capabilities: 
    :param credential: (:attr:`credential`) 
    :type credential: 
    :param reboot_preference: (:attr:`reboot_preference`) 
    :type reboot_preference: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'capabilities': 'list[vmm.v4.ahv.config.NgtCapability]',
        'credential': 'vmm.v4.ahv.config.Credential',
        'reboot_preference': 'vmm.v4.ahv.config.RebootPreference',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'capabilities': 'capabilities',
        'credential': 'credential',
        'reboot_preference': 'rebootPreference',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, capabilities=None, credential=None, reboot_preference=None, *args, **kwargs):  # noqa: E501
        self.__capabilities = None
        self.__credential = None
        self.__reboot_preference = None
        self.discriminator = None
        if capabilities is not None:
            self.__capabilities = capabilities
        if credential is not None:
            self.__credential = credential
        if reboot_preference is not None:
            self.__reboot_preference = reboot_preference
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'vmm.v4.ahv.config.GuestToolsInstallConfig'

    def _initialize_fq_object_type(self):
        return 'vmm.v4.r0.a1.ahv.config.GuestToolsInstallConfig'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def capabilities(self):
        """
        The list of the application names that are enabled on the guest VM.

        :type:
             list[ :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.NgtCapability` ]
        """  # noqa: E501
        return self.__capabilities

    @capabilities.setter
    def capabilities(self, capabilities):

        self.__capabilities = capabilities

    @property
    def credential(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.Credential`
        """  # noqa: E501
        return self.__credential

    @credential.setter
    def credential(self, credential):

        self.__credential = credential

    @property
    def reboot_preference(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.RebootPreference`
        """  # noqa: E501
        return self.__reboot_preference

    @reboot_preference.setter
    def reboot_preference(self, reboot_preference):

        self.__reboot_preference = reboot_preference

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(GuestToolsInstallConfig, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GuestToolsInstallConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

