# coding: utf-8


"""
IGNORE:
    Nutanix Vmm Versioned APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.3-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.EnforcementMode import EnforcementMode  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.PolicyComplianceState import PolicyComplianceState  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.PolicyReference import PolicyReference  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.ProtectionInfo import ProtectionInfo  # noqa: F401,E501

class ProtectionPolicyState(object):

    """Status of protection policy applied to this VM.

    :param compliance_status: (:attr:`compliance_status`) 
    :type compliance_status: 
    :param enforcement_mode: (:attr:`enforcement_mode`) 
    :type enforcement_mode: 
    :param policy: (:attr:`policy`) 
    :type policy: 
    :param policy_info: (:attr:`policy_info`) 
    :type policy_info: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'compliance_status': 'vmm.v4.ahv.config.PolicyComplianceState',
        'enforcement_mode': 'vmm.v4.ahv.config.EnforcementMode',
        'policy': 'vmm.v4.ahv.config.PolicyReference',
        'policy_info': 'vmm.v4.ahv.config.ProtectionInfo',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'compliance_status': 'complianceStatus',
        'enforcement_mode': 'enforcementMode',
        'policy': 'policy',
        'policy_info': 'policyInfo',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, compliance_status=None, enforcement_mode=None, policy=None, policy_info=None, *args, **kwargs):  # noqa: E501
        self.__compliance_status = None
        self.__enforcement_mode = None
        self.__policy = None
        self.__policy_info = None
        self.discriminator = None
        if compliance_status is not None:
            self.__compliance_status = compliance_status
        if enforcement_mode is not None:
            self.__enforcement_mode = enforcement_mode
        if policy is not None:
            self.__policy = policy
        if policy_info is not None:
            self.__policy_info = policy_info
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'vmm.v4.ahv.config.ProtectionPolicyState'

    def _initialize_fq_object_type(self):
        return 'vmm.v4.r0.a1.ahv.config.ProtectionPolicyState'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def compliance_status(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.PolicyComplianceState`
        """  # noqa: E501
        return self.__compliance_status

    @compliance_status.setter
    def compliance_status(self, compliance_status):

        self.__compliance_status = compliance_status

    @property
    def enforcement_mode(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.EnforcementMode`
        """  # noqa: E501
        return self.__enforcement_mode

    @enforcement_mode.setter
    def enforcement_mode(self, enforcement_mode):

        self.__enforcement_mode = enforcement_mode

    @property
    def policy(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.PolicyReference`
        """  # noqa: E501
        return self.__policy

    @policy.setter
    def policy(self, policy):

        self.__policy = policy

    @property
    def policy_info(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.ProtectionInfo`
        """  # noqa: E501
        return self.__policy_info

    @policy_info.setter
    def policy_info(self, policy_info):

        self.__policy_info = policy_info

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ProtectionPolicyState, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProtectionPolicyState):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

