# coding: utf-8


"""
IGNORE:
    Nutanix Vmm Versioned APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.3-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.AvailabilityZoneReference import AvailabilityZoneReference  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.ClusterReference import ClusterReference  # noqa: F401,E501
from ntnx_vmm_py_client.models.vmm.v4.ahv.config.VmCrossClusterMigrateOverrides import VmCrossClusterMigrateOverrides  # noqa: F401,E501

class VmCrossClusterMigrateParams(object):

    """Input on how to migrate a VM across clusters.

    :param target_availability_zone: (:attr:`target_availability_zone`) 
    :type target_availability_zone: 
    :param target_cluster: (:attr:`target_cluster`) 
    :type target_cluster: 
    :param is_live_migration: (:attr:`is_live_migration`) Indicates if the migration is performed with a running VM.
    :type is_live_migration: 
    :param overrides: (:attr:`overrides`) 
    :type overrides: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'target_availability_zone': 'vmm.v4.ahv.config.AvailabilityZoneReference',
        'target_cluster': 'vmm.v4.ahv.config.ClusterReference',
        'is_live_migration': 'bool',
        'overrides': 'vmm.v4.ahv.config.VmCrossClusterMigrateOverrides',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'target_availability_zone': 'targetAvailabilityZone',
        'target_cluster': 'targetCluster',
        'is_live_migration': 'isLiveMigration',
        'overrides': 'overrides',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, target_availability_zone=None, target_cluster=None, is_live_migration=None, overrides=None, *args, **kwargs):  # noqa: E501
        self.__target_availability_zone = None
        self.__target_cluster = None
        self.__is_live_migration = None
        self.__overrides = None
        self.discriminator = None
        if target_availability_zone is not None:
            self.__target_availability_zone = target_availability_zone
        if target_cluster is not None:
            self.__target_cluster = target_cluster
        if is_live_migration is not None:
            self.__is_live_migration = is_live_migration
        if overrides is not None:
            self.__overrides = overrides
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'vmm.v4.ahv.config.VmCrossClusterMigrateParams'

    def _initialize_fq_object_type(self):
        return 'vmm.v4.r0.a1.ahv.config.VmCrossClusterMigrateParams'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def target_availability_zone(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.AvailabilityZoneReference`
        """  # noqa: E501
        return self.__target_availability_zone

    @target_availability_zone.setter
    def target_availability_zone(self, target_availability_zone):

        self.__target_availability_zone = target_availability_zone

    @property
    def target_cluster(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.ClusterReference`
        """  # noqa: E501
        return self.__target_cluster

    @target_cluster.setter
    def target_cluster(self, target_cluster):

        self.__target_cluster = target_cluster

    @property
    def is_live_migration(self):
        """
        Indicates if the migration is performed with a running VM.

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__is_live_migration

    @is_live_migration.setter
    def is_live_migration(self, is_live_migration):

        self.__is_live_migration = is_live_migration

    @property
    def overrides(self):
        """
        

        :type:
            :class:`~ntnx_vmm_py_client.models.vmm.v4.ahv.config.VmCrossClusterMigrateOverrides`
        """  # noqa: E501
        return self.__overrides

    @overrides.setter
    def overrides(self, overrides):

        self.__overrides = overrides

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(VmCrossClusterMigrateParams, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VmCrossClusterMigrateParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

