# coding: utf-8


"""
IGNORE:
    Nutanix Vmm Versioned APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.3-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six

class ClusterRateLimitStatus(object):

    """Cluster image rate limit status.

    :param cluster_id: (:attr:`cluster_id`) Cluster extId.
    :type cluster_id: 
    :param effective_rate_limit_name: (:attr:`effective_rate_limit_name`) Name of the image rate limit currently enforced for a cluster.
    :type effective_rate_limit_name: 
    :param effective_rate_limit_id: (:attr:`effective_rate_limit_id`) Image rate limit extId currently enforced for a cluster.
    :type effective_rate_limit_id: 
    :param effective_rate_limit_kbps: (:attr:`effective_rate_limit_kbps`) The currently enforced rate limit for a cluster in KBps.
    :type effective_rate_limit_kbps: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'cluster_id': 'str',
        'effective_rate_limit_name': 'str',
        'effective_rate_limit_id': 'str',
        'effective_rate_limit_kbps': 'int',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'cluster_id': 'clusterId',
        'effective_rate_limit_name': 'effectiveRateLimitName',
        'effective_rate_limit_id': 'effectiveRateLimitId',
        'effective_rate_limit_kbps': 'effectiveRateLimitKbps',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, cluster_id=None, effective_rate_limit_name=None, effective_rate_limit_id=None, effective_rate_limit_kbps=None, *args, **kwargs):  # noqa: E501
        self.__cluster_id = None
        self.__effective_rate_limit_name = None
        self.__effective_rate_limit_id = None
        self.__effective_rate_limit_kbps = None
        self.discriminator = None
        if cluster_id is not None:
            self.__cluster_id = cluster_id
        if effective_rate_limit_name is not None:
            self.__effective_rate_limit_name = effective_rate_limit_name
        if effective_rate_limit_id is not None:
            self.__effective_rate_limit_id = effective_rate_limit_id
        if effective_rate_limit_kbps is not None:
            self.__effective_rate_limit_kbps = effective_rate_limit_kbps
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'vmm.v4.images.ClusterRateLimitStatus'

    def _initialize_fq_object_type(self):
        return 'vmm.v4.r0.a1.images.ClusterRateLimitStatus'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def cluster_id(self):
        """
        Cluster extId.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__cluster_id

    @cluster_id.setter
    def cluster_id(self, cluster_id):
        if cluster_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', cluster_id):  # noqa: E501
            raise ValueError(r"Invalid value for `cluster_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__cluster_id = cluster_id

    @property
    def effective_rate_limit_name(self):
        """
        Name of the image rate limit currently enforced for a cluster.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__effective_rate_limit_name

    @effective_rate_limit_name.setter
    def effective_rate_limit_name(self, effective_rate_limit_name):

        self.__effective_rate_limit_name = effective_rate_limit_name

    @property
    def effective_rate_limit_id(self):
        """
        Image rate limit extId currently enforced for a cluster.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__effective_rate_limit_id

    @effective_rate_limit_id.setter
    def effective_rate_limit_id(self, effective_rate_limit_id):
        if effective_rate_limit_id is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', effective_rate_limit_id):  # noqa: E501
            raise ValueError(r"Invalid value for `effective_rate_limit_id`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__effective_rate_limit_id = effective_rate_limit_id

    @property
    def effective_rate_limit_kbps(self):
        """
        The currently enforced rate limit for a cluster in KBps.

        :type:

                :class:`~int`
        """  # noqa: E501
        return self.__effective_rate_limit_kbps

    @effective_rate_limit_kbps.setter
    def effective_rate_limit_kbps(self, effective_rate_limit_kbps):

        self.__effective_rate_limit_kbps = effective_rate_limit_kbps

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ClusterRateLimitStatus, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClusterRateLimitStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

