# coding: utf-8


"""
IGNORE:
    Nutanix Vmm Versioned APIs

    Manage the life-cycle of virtual machines hosted on Nutanix  # noqa: E501

    OpenAPI spec version: 4.0.3-alpha-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six

class CompleteGuestUpdateSpec(object):

    """Input to Template Complete Guest OS Update.

    :param version_name: (:attr:`version_name`) Template version name. This will be the default VM name prefix when a VM is deployed from this template.
    :type version_name: required
    :param version_description: (:attr:`version_description`) A description for template version.
    :type version_description: required
    :param set_active_version: (:attr:`set_active_version`) Indicates whether the version has to be a Gold version or not. (**Default** False)
    :type set_active_version: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'version_name': 'str',
        'version_description': 'str',
        'set_active_version': 'bool',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'version_name': 'versionName',
        'version_description': 'versionDescription',
        'set_active_version': 'setActiveVersion',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, version_name=None, version_description=None, set_active_version=False, *args, **kwargs):  # noqa: E501
        self.__version_name = None
        self.__version_description = None
        self.__set_active_version = None
        self.discriminator = None
        self.__version_name = version_name
        self.__version_description = version_description
        if set_active_version is not None:
            self.__set_active_version = set_active_version
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'vmm.v4.templates.CompleteGuestUpdateSpec'

    def _initialize_fq_object_type(self):
        return 'vmm.v4.r0.a1.templates.CompleteGuestUpdateSpec'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fqObjectType": self._initialize_fq_object_type()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def version_name(self):
        """
        Template version name. This will be the default VM name prefix when a VM is deployed from this template.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__version_name

    @version_name.setter
    def version_name(self, version_name):
        if version_name is None:
            raise ValueError("Invalid value for `version_name`, must not be `None`")  # noqa: E501
        if version_name is not None and len(version_name) > 256:
            raise ValueError("Invalid value for `version_name`, length must be less than or equal to `256`")  # noqa: E501

        self.__version_name = version_name

    @property
    def version_description(self):
        """
        A description for template version.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__version_description

    @version_description.setter
    def version_description(self, version_description):
        if version_description is None:
            raise ValueError("Invalid value for `version_description`, must not be `None`")  # noqa: E501

        self.__version_description = version_description

    @property
    def set_active_version(self):
        """
        Indicates whether the version has to be a Gold version or not.

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__set_active_version

    @set_active_version.setter
    def set_active_version(self, set_active_version):

        self.__set_active_version = set_active_version

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}

        for attr, attr_type in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize))
                    if hasattr(item[1], "_to_dict") else item,
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(CompleteGuestUpdateSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CompleteGuestUpdateSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

